﻿using System;
using System.Data;
using System.Diagnostics;
using System.Threading;
using MySql.Data.MySqlClient;

namespace BugReport58316
{
    public class TestBug
    {


        public static void Main(string[] args)
        {
            string strConnectionString = "Server = localhost; Database = testdb; Uid = root; Pwd = root;";

            string strSelectQuery = "select id_maintable, content from testdb.maintable";

            MySqlConnection dbcConnection = new MySqlConnection(strConnectionString);

            Log(string.Format("connection state : {0}", dbcConnection.State));

            dbcConnection.Open();

            MySqlCommand mscCommand = new MySqlCommand(strSelectQuery, dbcConnection) { CommandType = CommandType.Text };

            MySqlDataReader msReader = mscCommand.ExecuteReader();

            bool bRead = msReader.Read();

            Log(string.Format("Read from mysql data reader : {0}", bRead));

            msReader.Close();

            Log("You have 40 seconds to stop and start MySql service, DO SO NOW !");

            Thread.Sleep(40000);

            Log("Continuing...");

            Log(string.Format("connection state : {0}", dbcConnection.State));

            Log(string.Format("Expected connection still opened. Result : {0}",
                dbcConnection.State == ConnectionState.Open));

            // instantiate a new command object as in my code (new http request etc)

            mscCommand = new MySqlCommand(strSelectQuery, dbcConnection) { CommandType = CommandType.Text };

            try
            {
                msReader = mscCommand.ExecuteReader();

                bRead = msReader.Read();

                Log(string.Format("Read from mysql data reader : {0}", bRead));
            }
            catch (MySqlException msEx)
            {
                Log(string.Format("Err, MySqlException : {0} {1}", msEx.Message, msEx.StackTrace));
                Log("Going to closing connection and clear pool...");

                try
                {
                    dbcConnection.Close();
                    MySqlConnection.ClearPool(dbcConnection);
                }
                catch (Exception ex)
                {
                    Log(string.Format("Err, error during connection closing/pool clearing : {0} {1}",
                        ex.Message, ex.StackTrace));
                }

                try
                {
                    Log(string.Format("connection state : {0}", dbcConnection.State));
                    Log("Going to reopen connection");
                    dbcConnection.Open();
                }
                catch (Exception ex)
                {
                    Log(string.Format("Err, error during connection reopening : {0} {1}",
                        ex.Message, ex.StackTrace));
                }
            } finally
            {
                msReader.Close();
            }



        }

        private static void Log(string strMessage_)
        {
            Console.WriteLine(strMessage_);
            Debug.WriteLine(strMessage_);
        }
    }
}
